apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ zookeeper_name }}
  name: {{ zookeeper_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
  replicas: {{ zookeeper_replicas }}
  selector:
    matchLabels:
      name: {{ zookeeper_name }}
  serviceName: {{ zookeeper_name }}
  template:
    metadata:
      labels:
        name: {{ zookeeper_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ zookeeper_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ zookeeper_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: JAVA_ZK_JVMFLAG
          value: "\"{{ zookeeper_heap_size | join(' ') }}"\"
        - name: SETUP_DEBUG
          value: "{% if do_debugs %}true{% endif %}"
        - name: TZ
          value: {{ timezone }}
        - name: ZK_autopurge_purgeInterval
          value: "{{ zookeeper_purge_interval }}"
        - name: ZK_autopurge_snapRetainCount
          value: "{{ zookeeper_snap_retain_count }}"
        - name: ZK_clientPort
          value: "2181"
        - name: ZK_initLimit
          value: "{{ zookeeper_init_limit }}"
        - name: ZK_maxClientCnxns
          value: "{{ zookeeper_max_clients }}"
        - name: ZK_syncLimit
          value: "{{ zookeeper_sync_limit }}"
        - name: ZK_tickTime
          value: "{{ zookeeper_tick_time }}"
        - name: ZK_HEAP_SIZE
          value: {{ zookeeper_heap_size | join(' ') }}
        - name: ZOO_ELECTION_PORT
          value: "3888"
        - name: ZOO_REPLICAS
          value: "{{ zookeeper_replicas }}"
        - name: ZOO_SERVER_PORT
          value: "2888"
        image: {{ (opsimages | json_query("[?name=='zookeeper'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - zk_status.sh
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 10
        name: zookeeper
        ports:
        - name: client
          containerPort: 2181
        - name: server
          containerPort: 2888
        - name: elections
          containerPort: 3888
        readinessProbe:
          exec:
            command:
            - zk_status.sh
          initialDelaySeconds: 20
          timeoutSeconds: 10
        resources:
          limits:
            cpu: "{{ zookeeper_cpu_limit }}"
            memory: "{{ zookeeper_memory_limit }}"
          requests:
            cpu: "{{ zookeeper_cpu_limit }}"
            memory: "{{ zookeeper_memory_limit }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          exec:
            command:
            - zk_status.sh
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 10
{% endif %}
        volumeMounts:
        - mountPath: /opt/zookeeper/data
          name: data
          subPath: db
        - mountPath: /opt/zookeeper/data-log
          name: data
          subPath: log
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ zookeeper_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ zookeeper_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
